//
//  MessagePublisher.m
//  Tutorial1
//
//  Created by Martin Ott on 10/27/05.
//  Copyright 2005 TUM. All rights reserved.
//

#import "MessagePublisher.h"


@implementation MessagePublisher

- (id)init {
    [super init];
    subscribers = [NSMutableArray new];
    return self;
}

- (void)dealloc {
    [subscribers release];
    [super dealloc];
}

- (int)numberOfSubscribers {
    return [subscribers count];
}

- (void)subscribe:(MessageSubscriber *)subscriber {
    [subscribers addObject:subscriber];
}

- (void)unsubscribe:(MessageSubscriber *)subscriber {
    [subscribers removeObject:subscriber];
}

- (NSArray *)subscribers {
    return subscribers;
}

- (void)publishMessage:(NSString *)message {
    MessageSubscriber *subscriber;
    NSEnumerator *subscribersEnumerator = [[self subscribers] objectEnumerator];
    while ((subscriber = [subscribersEnumerator nextObject])) {
        [subscriber receiveMessage:message];
    }
}


@end
